import { QueryKey } from '@tanstack/react-query';

type Query = Partial<{
    list: Function;
    detail: Function;
    create: Function;
    update: Function;
    delete: Function;
    [key: string]: Function;
}>;
type CreateInput<Q extends Query> = {
    root: QueryKey;
    query: Q;
};
type Store<Q extends Query> = {
    key: {
        root: QueryKey;
        base: Record<keyof Q, QueryKey>;
        generator: Record<keyof Q, (queryKey?: QueryKey) => QueryKey>;
    };
    query: Q;
};
declare const create: <Q extends Query>(input: Partial<CreateInput<Q>>) => Store<Q>;

export { type CreateInput, type Store, create };
